/*
 File: rule_def_phrase.h
 Date and Time: Fri Jan 30 18:55:22 2015 
*/
#ifndef __rule_def_phrase_h__
#define __rule_def_phrase_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "lint_balls.h"
#include "cweb_or_c_k.h"
#include "identifier.h"
#include "c_string.h"
#include "t_def_delabort_tags.h"
#include "subrules_phrase.h"
#include "rule_lhs_phrase.h"
#include "yacco2_stbl.h"
#include "parallel_monitor_ph.h"
  
extern yacco2::Thread_entry ITH_rule_def_phrase;

extern yacco2::State S1_Crule_def_phrase;
namespace NS_rule_def_phrase {
yacco2::THR _YACCO2_CALL_TYPE
TH_rule_def_phrase(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_rule_def_phrase(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[16];
};
class Crule_def_phrase: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rrule_def_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rrule_def_phrase_ = 1
   ,R_Rrule_cweb_k_ = 570//start_of_rule_list + 2
    ,rhs1_Rrule_cweb_k_ = 2
    ,rhs2_Rrule_cweb_k_ = 3
    ,rhs3_Rrule_cweb_k_ = 4
   ,R_Rid_ = 571//start_of_rule_list + 4
    ,rhs1_Rid_ = 5
    ,rhs2_Rid_ = 6
    ,rhs3_Rid_ = 7
    ,rhs4_Rid_ = 8
   ,R_Rad_ab_tags_ = 572//start_of_rule_list + 6
    ,rhs1_Rad_ab_tags_ = 9
    ,rhs2_Rad_ab_tags_ = 10
    ,rhs3_Rad_ab_tags_ = 11
   ,R_Rad_ab_tag_ = 573//start_of_rule_list + 8
    ,rhs1_Rad_ab_tag_ = 12
    ,rhs2_Rad_ab_tag_ = 13
   ,R_Rrule_parameters_ = 574//start_of_rule_list + 10
    ,rhs1_Rrule_parameters_ = 14
    ,rhs2_Rrule_parameters_ = 15
    ,rhs3_Rrule_parameters_ = 16
   ,R_Rrule_parameter_ = 575//start_of_rule_list + 12
    ,rhs1_Rrule_parameter_ = 17
    ,rhs2_Rrule_parameter_ = 18
    ,rhs3_Rrule_parameter_ = 19
   ,R_Rlhs_phrase_ = 576//start_of_rule_list + 14
    ,rhs1_Rlhs_phrase_ = 20
    ,rhs2_Rlhs_phrase_ = 21
   ,R_Rparallel_monitor_phrase_ = 577//start_of_rule_list + 16
    ,rhs1_Rparallel_monitor_phrase_ = 22
    ,rhs2_Rparallel_monitor_phrase_ = 23
   ,R_Rrule_body_ = 578//start_of_rule_list + 18
    ,rhs1_Rrule_body_ = 24
   ,R_Rsubrules_ = 579//start_of_rule_list + 20
    ,rhs1_Rsubrules_ = 25
    ,rhs2_Rsubrules_ = 26
    ,rhs3_Rsubrules_ = 27
   ,R_Ropen_par_ = 580//start_of_rule_list + 22
    ,rhs1_Ropen_par_ = 28
    ,rhs2_Ropen_par_ = 29
   ,R_Rclose_par_ = 581//start_of_rule_list + 24
    ,rhs1_Rclose_par_ = 30
    ,rhs2_Rclose_par_ = 31
   ,R_Ropen_brace_ = 582//start_of_rule_list + 26
    ,rhs1_Ropen_brace_ = 32
    ,rhs2_Ropen_brace_ = 33
   ,R_Rclose_brace_ = 583//start_of_rule_list + 28
    ,rhs1_Rclose_brace_ = 34
    ,rhs2_Rclose_brace_ = 35
   ,R_Rlint_ = 584//start_of_rule_list + 30
    ,rhs1_Rlint_ = 36
    ,rhs2_Rlint_ = 37
  };
  //no of la sets = 10
  //no of states = 64
  Crule_def_phrase();
  ~Crule_def_phrase();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[38];
  
    public:
    rule_def* rule_def_;
  
 };
struct Rrule_def_phrase;
struct Rrule_cweb_k;
struct Rid;
struct Rad_ab_tags;
struct Rad_ab_tag;
struct Rrule_parameters;
struct Rrule_parameter;
struct Rlhs_phrase;
struct Rparallel_monitor_phrase;
struct Rrule_body;
struct Rsubrules;
struct Ropen_par;
struct Rclose_par;
struct Ropen_brace;
struct Rclose_brace;
struct Rlint;
struct Rrule_def_phrase:public yacco2::CAbs_lr1_sym {
  Rrule_def_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rrule_cweb_k:public yacco2::CAbs_lr1_sym {
  Rrule_cweb_k(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rid:public yacco2::CAbs_lr1_sym {
  Rid(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
};

struct Rad_ab_tags:public yacco2::CAbs_lr1_sym {
  Rad_ab_tags(yacco2::Parser* P);
  public:
};

struct Rad_ab_tag:public yacco2::CAbs_lr1_sym {
  Rad_ab_tag(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rrule_parameters:public yacco2::CAbs_lr1_sym {
  Rrule_parameters(yacco2::Parser* P);
  public:
};

struct Rrule_parameter:public yacco2::CAbs_lr1_sym {
  Rrule_parameter(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rlhs_phrase:public yacco2::CAbs_lr1_sym {
  Rlhs_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rparallel_monitor_phrase:public yacco2::CAbs_lr1_sym {
  Rparallel_monitor_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rrule_body:public yacco2::CAbs_lr1_sym {
  Rrule_body(yacco2::Parser* P);
  public:
};

struct Rsubrules:public yacco2::CAbs_lr1_sym {
  Rsubrules(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Ropen_par:public yacco2::CAbs_lr1_sym {
  Ropen_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_par:public yacco2::CAbs_lr1_sym {
  Rclose_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Ropen_brace:public yacco2::CAbs_lr1_sym {
  Ropen_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_brace:public yacco2::CAbs_lr1_sym {
  Rclose_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

} // end of namespace

#endif
